#include "GUIConvertLocalizationTF.h"
#include "ui_GUIConvertLocalizationTF.h"
#include "GUICommon.h"
#include "GUIMainWindow.h"

GUIConvertLocalizationTF::GUIConvertLocalizationTF(QWidget *parent) :
	QDialog(parent), ui(new Ui::GUIConvertLocalizationTF) {
	ui->setupUi(this);
	::setWindowTitle(this);
}

GUIConvertLocalizationTF::~GUIConvertLocalizationTF() {
	delete ui;
}

void GUIConvertLocalizationTF::convert() {

	GUIMainWindow *main = GUIMainWindow::getMainWindow();
	GUITabDocument* guidoc = NULL;

	try {
		// マイクファイル読み込み
		std::vector<harkio::UIMic<> > mic_list;
		harkio::TextData files;
		harkio::TextBase *file;
		file = files.readFile(ui->mic_file->text().toStdString());
		mic_list = ((harkio::MICARYLocationFile*) file)->mic_lists;

		QTabWidget *tab = main->secondTabWidget();
		guidoc = dynamic_cast<GUITabDocument*> (tab->currentWidget());
		GUILocalizationTF* guidoc2 = (GUILocalizationTF*) guidoc;
		HT::UIDocument *base = guidoc->getDoc();
		HT::MUSIC::UIDocument* uidoc = (HT::MUSIC::UIDocument*) base;
		HT::MUSIC::UIData *data = uidoc->getUIData();

		// マイクファイルの型の変換
		std::vector<HT::UIMic<HT_DATA_TYPE> > mic_list2;
		for(uint i=0; i < mic_list.size(); i++) {
			mic_list2[i].convertFromHarkIO(mic_list[i]);
		}

		// 新規作成時に、データをhakrioのコンテナにすべて移動する
		HT::MUSIC::moveToHARKIOParam param;
		param.NMic = data->getNMic();
		param.NFFT = data->getNFFT();
		param.NIR = ui->impulse_response_length->value();
		param.NFS = data->getNFS();
		param.src_list = data->getSrc();
		param.mic_list = &mic_list2;
		param.tf_matrix = data->getMatrix();
		data->moveToHARKIO(param);
		guidoc2->disp();
		DISP_INFO("Conversion completed.");
		main->uiUpdate();
		done(0);
	} catch (std::exception& exp) {
		DISP_DIALOG(exp);
		return;
	}

}

void GUIConvertLocalizationTF::selectFile() {

	try {
		QString fname = QFileDialog::getOpenFileName(this, "MICARY-LocationFile", HT::UIDocument::getLastPath(
				ui->mic_file->text().toStdString()).c_str());
		if (fname != "") {
			ui->mic_file->setText(fname);
			HT::UIDocument::setLastPath(fname.toStdString());
		}
	} catch (std::exception& exp) {
		DISP_DIALOG(exp);
		return;
	}
}

void GUIConvertLocalizationTF::changeEvent(QEvent *e) {
	QDialog::changeEvent(e);
	switch (e->type()) {
	case QEvent::LanguageChange:
		ui->retranslateUi(this);
		break;
	default:
		break;
	}
}
