#ifndef GUILocalizationTFNew_H
#define GUILocalizationTFNew_H

#include <QDialog>
#include "GUILocalizationTF.h"
#include "UIDatDocument.h"

namespace Ui {
class GUILocalizationTFNew;
}
namespace HT {
namespace MUSIC {
class UIData;
}
}
class GUILocalizationTFNew: public QDialog {
Q_OBJECT
protected:
	// ダイアログ表示前に、コンボボックス作成情報を、ここに格納します。
	QVector<QPair<QString, QString> > tsp_files;
	QVector<QPair<QString, QString> > mic_files;
	QVector<QPair<QString, QString> > impulse_files;

public:
	GUILocalizationTFNew(QWidget *parent = 0);
	~GUILocalizationTFNew();

	void pushTSPFiles(QString name, QString fname) {
		tsp_files.push_back(QPair<QString, QString>(name, fname));
	}
	void pushMicFiles(QString name, QString fname) {
		mic_files.push_back(QPair<QString, QString>(name, fname));
	}
	void pushImpulseFiles(QString name, QString fname) {
		impulse_files.push_back(QPair<QString, QString>(name, fname));
	}
	void updateComboBox();

protected:
	void changeEvent(QEvent *e);
	void experimental_create();
	void theoretical_create();

private slots:
	void ok_clicked();
	void making_method_clicked();
	void signal_data_clicked();
	void mic_location_clicked();
	void src_location_clicked();
	void createdTSP(int current, int total, HT::UIData *data);
	void changeComboBox(int index);

signals:
void createdData(GUITabDocument *guidoc);
private:
	Ui::GUILocalizationTFNew *ui;
};

#endif // GUILocalizationTFNew_H
