#include "GUINewFileSelect.h"
#include "ui_GUINewFileSelect.h"

GUINewFileSelect::GUINewFileSelect(QWidget *parent) :
	QDialog(parent), ui(new Ui::GUINewFileSelect) {
	ui->setupUi(this);

	::setWindowTitle(this);
}

GUINewFileSelect::~GUINewFileSelect() {
	delete ui;
}


void GUINewFileSelect::displayLocalizationTFNew() {
	try {
		GUIMainWindow *main = GUIMainWindow::getMainWindow();

		// 新規作成、パラメータ入力画面
		GUILocalizationTFNew dialog(this);

		// コンボボックスに、他のタブの情報を表示する為の準備を行う
		QTabWidget *tab;
		tab = main->secondTabWidget(HT::UIApp::MIC);

		if (tab) {
			QString fname;
			GUIMicaryLocationFile* gui_doc;
			for (int i =0; i< tab->count(); i++) {
				gui_doc = dynamic_cast<GUIMicaryLocationFile*> (tab->widget(i));
				fname = gui_doc->getDoc()->getFileName().c_str();
				if (fname != "") {
					dialog.pushMicFiles("MICARY-LocationFile::" + tab->tabText(i), fname);
				}
			}
		}
		tab = main->secondTabWidget(HT::UIApp::IMPULSE);
		if (tab) {
			QString fname;
			GUIImpulseResponseListFile*gui_doc;
			for (int i =0; i< tab->count(); i++) {
				gui_doc = dynamic_cast<GUIImpulseResponseListFile*> (tab->widget(i));
				fname = gui_doc->getDoc()->getFileName().c_str();
				if (fname != "") {
					dialog.pushImpulseFiles("ImpulseResponse-ListFile::" + tab->tabText(i), fname);
				}
			}
		}
		tab = main->secondTabWidget(HT::UIApp::TSP);
		if (tab) {
			QString fname;
			GUITSPListFile* gui_doc;
			for (int i =0; i< tab->count(); i++) {
				gui_doc = dynamic_cast<GUITSPListFile*> (tab->widget(i));
				fname = gui_doc->getDoc()->getFileName().c_str();
				if (fname != "") {
					dialog.pushTSPFiles("TSP-ListFile::" + tab->tabText(i), fname);
				}
			}
		}
		dialog.updateComboBox();

		connect(&dialog, SIGNAL(createdData(GUITabDocument*)), main, SLOT(createDocument(GUITabDocument*)));
		int ret = dialog.exec();
		if (ret < 0) {
			close();
		}
		disconnect(&dialog, SIGNAL(createdData(GUITabDocument*)), main, SLOT(createDocument(GUITabDocument*)));
	} catch (std::exception& exp) {
		DISP_DIALOG(exp);
		return;
	}
	return;
}

void GUINewFileSelect::displaySeparationTFNew() {

	try {
		// 新規作成、パラメータ入力画面
		GUISeparationTFNew dialog(this);
		GUIMainWindow *main = GUIMainWindow::getMainWindow();

		// コンボボックスに、他のタブの情報を表示する為の準備を行う
		QTabWidget *tab;

		tab = main->secondTabWidget(HT::UIApp::MIC);
		if (tab) {
			QString fname;
			GUIMicaryLocationFile* gui_doc;
			for (int i =0; i< tab->count(); i++) {
				gui_doc = dynamic_cast<GUIMicaryLocationFile*> (tab->widget(i));
				fname = gui_doc->getDoc()->getFileName().c_str();
				if (fname != "") {
					dialog.pushMicFiles("MICARY-LocationFile::" + tab->tabText(i), fname);
				}
			}
		}
		tab = main->secondTabWidget(HT::UIApp::IMPULSE);
		if (tab) {
			QString fname;
			GUIImpulseResponseListFile* gui_doc;
			for (int i =0; i< tab->count(); i++) {
				gui_doc = dynamic_cast<GUIImpulseResponseListFile*> (tab->widget(i));
				fname = gui_doc->getDoc()->getFileName().c_str();
				if (fname != "") {
					dialog.pushImpulseFiles("ImpulseResponse-ListFile::" + tab->tabText(i), fname);
				}
			}
		}
		tab = main->secondTabWidget(HT::UIApp::TSP);
		if (tab) {
			QString fname;
			GUITSPListFile* gui_doc;
			for (int i =0; i< tab->count(); i++) {
				gui_doc = dynamic_cast<GUITSPListFile*> (tab->widget(i));
				fname = gui_doc->getDoc()->getFileName().c_str();
				if (fname != "") {
					dialog.pushTSPFiles("TSP-ListFile::" + tab->tabText(i), fname);
				}
			}
		}

		dialog.updateComboBox();

		connect(&dialog, SIGNAL(createdData(GUITabDocument*)), main, SLOT(createDocument(GUITabDocument*)));
		int ret = dialog.exec();
		if (ret < 0) {
			close();
		}
		disconnect	(&dialog, SIGNAL(createdData(GUITabDocument*)), main, SLOT(createDocument(GUITabDocument*)));
	} catch (std::exception& exp) {
		DISP_DIALOG(exp);
		return;
	}
	return;
}
void GUINewFileSelect::displayMicaryLocationFile() {

	GUIMicaryLocationFile *doc = NULL;
	try {
		doc = new GUIMicaryLocationFile(NULL);
		// メインウィンドウに通知
		emit createdData(doc);
		done(-1);
	} catch (std::exception& exp) {
		delete doc;
		DISP_DIALOG(exp);
		return;
	}
	return;
}
void GUINewFileSelect::displayNoiseLocationFile() {

	GUINoiseLocationFile* doc = NULL;
	try {
		doc = new GUINoiseLocationFile(NULL);
		// メインウィンドウに通知
		emit createdData(doc);
		done(-1);
	} catch (std::exception& exp) {
		delete doc;
		DISP_DIALOG(exp);
		return;
	}
	return;
}
void GUINewFileSelect::displayTSPListFile() {

	GUITSPListFile* doc = NULL;
	try {
		doc = new GUITSPListFile(NULL);

		// メインウィンドウに通知
		emit createdData(doc);
		done(-1);
	} catch (std::exception& exp) {
		delete doc;
		DISP_DIALOG(exp);
		return;
	}
	return;
}
void GUINewFileSelect::displayImpulseResponseListFile() {

	GUIImpulseResponseListFile *doc = NULL;
	try {
		doc = new GUIImpulseResponseListFile(NULL);
		// メインウィンドウに通知
		emit createdData(doc);
		done(-1);
	} catch (std::exception& exp) {
		delete doc;
		DISP_DIALOG(exp);
		return;
	}
	return;
}


void GUINewFileSelect::changeEvent(QEvent *e) {
	QDialog::changeEvent(e);
	switch (e->type()) {
	case QEvent::LanguageChange:
		ui->retranslateUi(this);
		break;
	default:
		break;
	}
}
