#include "GUINoiseLocationFileTemplateNew.h"
#include "ui_GUINoiseLocationFileTemplateNew.h"

#include <math.h>
#include "GUICommon.h"


GUINoiseLocationFileTemplateNew::GUINoiseLocationFileTemplateNew(
		QWidget *parent) :
	QDialog(parent), ui(new Ui::GUINoiseLocationFileTemplateNew) {
	ui->setupUi(this);

	::setWindowTitle(this);
}

GUINoiseLocationFileTemplateNew::~GUINoiseLocationFileTemplateNew()
{
	delete ui;
}

void GUINoiseLocationFileTemplateNew::createTemplate() {

	try {
		QStringList lines;

		double phi = ui->phi_from->value();
		double radius = ui->radius->value();
		double theta = ui->theta->value();

		lines << QString("# Noise-LocationFile generated from harktool by %1.").arg(getUserName());
		lines << QString("# DateTime: %1").arg(QDateTime::currentDateTime().toString("yyyy/MM/dd HH:mm:ss"));
		lines << "Noise-LocationFile";
		lines << "Version = " + QString("%1").arg("1.0");
		lines << "NumOfPosition = " + QString("%1").arg(int(1));

		double x = radius * cos(theta * M_PI / 180) * cos(phi * M_PI / 180);
		double y = radius * cos(theta * M_PI / 180) * sin(phi * M_PI / 180);
		double z = radius * sin(theta * M_PI / 180);
		lines << "Position " + QString("-1, %2, %3, %4").arg(x,7,'f',4).arg(y,7,'f',4).arg(z,7,'f',4);
		QString text = lines.join("\n");
		text += "\n";
		emit createdTemplate(text);
		close();
	} catch (std::exception& exp) {
		DISP_DIALOG(exp);
		return;
	}
	return;
}

void GUINoiseLocationFileTemplateNew::changeEvent(QEvent *e) {
	QDialog::changeEvent(e);
	switch (e->type()) {
	case QEvent::LanguageChange:
		ui->retranslateUi(this);
		break;
	default:
		break;
	}
}
