#ifndef GUIPLOTPARAMETERPANEL_H
#define GUIPLOTPARAMETERPANEL_H
#include <QDialog>

#include "UIDatDocument.h"


namespace Ui {
class GUIPlotParameterPanel;
}
//class QComboBox;
#include <QComboBox>
#include "common.h"

class GUIPlotParameterPanel: public QDialog {
Q_OBJECT
private:
	int mic;
	int src;
	int window;
	int fs;
	HT::UIDocument* doc;

public:
	class TF_AXIS {public: enum {UNDEFINE, TIME, FREQ, SRCPOS, MIC};};
	class TARGET {public: enum {UNDEFINE, TF, IFFT, DIFF};};

	GUIPlotParameterPanel(HT::UIDocument* doc, QWidget *parent = 0);
	~GUIPlotParameterPanel();

//	void resetDisplayTarget(int id); // TARGET id
	void setDisplayTargetToCombo(QComboBox *combo);
	void setTFAxisToCombo(QComboBox *combo);
	void setIFFTAxisToCombo(QComboBox *combo);

	void connectPlotStyle(bool value);
	void connectPlotCombo(bool value);
//	void connectIFFTPlotCombo(bool value);
//	void connectDiffPlotCombo(bool value);

	void setMicCombo(QComboBox *combo);
	void setFreqCombo(QComboBox *combo);
	void setSrcPosCombo(QComboBox *combo);
	void setTimeCombo(QComboBox *combo);
	void setProtStyleCombo();
	// XY軸以外のコンボボックスの値から、表示対象となるマトリックスのインデックスを取得する
	void setIndex(std::vector<int> *indexes, int xyz_axis, int specific_axis);
	std::string zUnitName(int id);
	std::string createTFTitle();
	std::string createIFFTTitle();
	std::string createDiffTitle();

	void presetTFGraph(GNUPlot<std::complex<double>, 3>& graph);
	void presetDiffGraph(GNUPlot<std::complex<double>, 3>& graph);
	void presetIFFTGraph(GNUPlot<std::complex<double>, 3>& graph);

	/*
	 *  コンボボックスの組み合わせから残りのパラメータのIDを返します
	 *  判断できないときは、UNDEFINEを返します
	 * GUIPlotParameterPanel::TF_AXIS: x_unit ,y_unit
	 * GUIPlotParameterPanel::TARGET: target
	 */
	int otherUnit(int target, int x_unit, int y_unit);

protected:
	void changeEvent(QEvent *e);

private:
	Ui::GUIPlotParameterPanel *ui;

public slots:
	void parameterInteract();
	void plotStyleInteract();
	void dispGraph();
//	void dispIFFT();
//	void dispDiff();
	void reset();
	void exportData();

};

#endif // GUIPLOTPARAMETERPANEL_H
