#include "UIApp.h"
#include "common.h"
#include "libharkio/libharkio.h"

using namespace std;
namespace HT {

UIApp::~UIApp() {}

UIApp::GROUPID UIApp::groupID(HT::UIDocument* doc) {

	if (dynamic_cast<HT::MUSIC::UIDocument*> (doc)) {
		return MUSIC;
	} else if (dynamic_cast<HT::GSS::UIDocument*> (doc)) {
		return GSS;
//	} else if (dynamic_cast<HT::GSSMAT::UIDocument*> (doc)) {
//		return GSSMAT;
	} else if (dynamic_cast<HT::MIC::UIDocument*> (doc)) {
		return MIC;
	} else if (dynamic_cast<HT::NOISE::UIDocument*> (doc)) {
		return NOISE;
	} else if (dynamic_cast<HT::TSP::UIDocument*> (doc)) {
		return TSP;
	} else if (dynamic_cast<HT::IMPULSE::UIDocument*> (doc)) {
		return IMPULSE;
	} else {
		THROW_EXCEPTION("dynamic castに失敗しました。");
	}
}

HT::UIApp::GROUPID UIApp::convIDHarkToolTextToDocument(int id) {
	switch(id) {
		case harkio::TextData::TYPE::ImpulseResponseListFile:
			return HT::UIApp::IMPULSE;
			break;
		case harkio::TextData::TYPE::TSPListFile:
			return HT::UIApp::TSP;
			break;
		case harkio::TextData::TYPE::MICARYLocationFile:
			return HT::UIApp::MIC;
			break;
		case harkio::TextData::TYPE::NoiseLocationFile:
			return HT::UIApp::NOISE;
			break;
		default:
			return HT::UIApp::UNDEFINEDID;
			break;
	}
}

} //namespace
