#include "UIException.h"

#include "common.h"

namespace HT {

UIException::UIException(const QString aMessage) : message(aMessage) {}
UIException::UIException(const std::string aMessage) : message(QString(aMessage.c_str())) {}
UIException::UIException(const char* aMessage) : message(QString(aMessage)) {}


UIException::UIException(const QString aMessage, const char* aFile,
		const char* aFunction, const int aLine)
 : message(aMessage), fileName(aFile), functionName(aFunction), line(aLine) {}
UIException::UIException(const std::string aMessage, const char* aFile,
		const char* aFunction, const int aLine)
 : message(QString(aMessage.c_str())), fileName(aFile), functionName(aFunction), line(aLine) {}

UIException::UIException(const char* aMessage, const char* aFile,
		const char* aFunction, const int aLine)
 : message(QString(aMessage)), fileName(aFile), functionName(aFunction), line(aLine) {}


UIException::~UIException() throw() {}

const char* UIException::what() const throw() {
    return message.toStdString().c_str();
}

const char* UIException::getFileName() const {
        return fileName;
}

const char* UIException::getFunctionName() const {
        return functionName;
}

int UIException::getLineNumber() const {
        return line;
}

} //namespace
 
