#include <cstdio>
#include <cstdlib>
#include <sys/stat.h>
#include <climits>

#include <iostream>
#include <string>
#include <sstream>
#include <vector>
#include <map>
#include <QProcess>

#include "common.h"

using namespace std;

string fullPathToFile(string fullpath) {
	int offset=0;
	if ((offset = fullpath.find_last_of("/")) >=0) {
		if ((unsigned)offset == fullpath.size()-1) {
			return "";
		}
		fullpath = fullpath.substr(offset + 1);
	}
	return fullpath;
}
string fullPathToPath(string fullpath){
	int offset=0;
	if ((offset = fullpath.find_last_of("/")) >=0) {
		if (offset == 0) {
			return "";
		}
		fullpath = fullpath.substr(0, offset+1);
	}
	return fullpath;
}

// テンポラリや設定ファイルを置くディレクトリ
std::string harktoolDir() {

	QDir dir;
	QString path;

	path = dir.homePath();
	path = path + "/" + TEMPORARY_PATH.c_str();
	dir.mkdir(path);

	return path.toStdString();
}

QString getUserName() {
	QString name;
	QStringList environment = QProcess::systemEnvironment();
	for (int i=0; i < environment.size(); i++)  {
		QRegExp reg("(?:USER|USERNAME)=(.+)");
		int ret = reg.indexIn(environment[i]);
		if (ret >= 0) {
			name = reg.cap(1);
			break;
		}
	}
	return name;
}

#if false
void pathOnly(QDir& dir) {
	QFileInfo file(dir.path());
	if (file.isFile()) {
		dir.cdUp();
	}
}

void setBasePath(QDir base, QDir& target) {

	if (!target.isAbsolute()) {
		QString new_path = QString("%1/%2").arg(base.path()).arg(target.path());
		target.setPath(new_path);
	}
}

QString basedPath(QString base, QString target) {
	QDir base_path(base);
	QDir target_path(target);
	pathOnly(base_path);
	setBasePath(base_path, target_path);
	return target_path.canonicalPath();
}
#endif

#include <sndfile.h>

bool checkSoundFile(std::string file) {

	SNDFILE *sf;
	SF_INFO sfinfo;
	char cha_fname[PATH_MAX];
	snprintf(cha_fname, sizeof(cha_fname)-1, "%s", file.c_str());
	sf = sf_open(cha_fname, SFM_READ, &sfinfo);
//	sf = sf_open(file.c_str(), SFM_READ, &sfinfo);
	if (!sf) {
		return false;
	} else {
		sf_close(sf);
		return  true;
	}
}

